import { GraphQLResolveInfo, GraphQLScalarType, GraphQLScalarTypeConfig } from 'graphql';
export type Maybe<T> = T | null;
export type InputMaybe<T> = Maybe<T>;
export type Exact<T extends {
    [key: string]: unknown;
}> = {
    [K in keyof T]: T[K];
};
export type MakeOptional<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]?: Maybe<T[SubKey]>;
};
export type MakeMaybe<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]: Maybe<T[SubKey]>;
};
export type MakeEmpty<T extends {
    [key: string]: unknown;
}, K extends keyof T> = {
    [_ in K]?: never;
};
export type Incremental<T> = T | {
    [P in keyof T]?: P extends ' $fragmentName' | '__typename' ? T[P] : never;
};
export type RequireFields<T, K extends keyof T> = Omit<T, K> & {
    [P in K]-?: NonNullable<T[P]>;
};
/** All built-in and custom scalars, mapped to their actual values */
export type Scalars = {
    ID: {
        input: string;
        output: string;
    };
    String: {
        input: string;
        output: string;
    };
    Boolean: {
        input: boolean;
        output: boolean;
    };
    Int: {
        input: number;
        output: number;
    };
    Float: {
        input: number;
        output: number;
    };
    AnyObject: {
        input: any;
        output: any;
    };
    Date: {
        input: any;
        output: any;
    };
    DateTime: {
        input: any;
        output: any;
    };
    JSON: {
        input: any;
        output: any;
    };
    JSONObject: {
        input: any;
        output: any;
    };
    Observable: {
        input: any;
        output: any;
    };
    Time: {
        input: any;
        output: any;
    };
    URI: {
        input: any;
        output: any;
    };
    URIInput: {
        input: any;
        output: any;
    };
};
export type IAdminIdeSettings = {
    __typename?: 'AdminIdeSettings';
    dummy?: Maybe<Scalars['Int']['output']>;
};
export declare enum ICacheControlScope {
    Private = "PRIVATE",
    Public = "PUBLIC"
}
/** Represents a null return value. */
export type IEmptyResponse = {
    __typename?: 'EmptyResponse';
    alwaysNil?: Maybe<Scalars['String']['output']>;
};
export type IFieldError = {
    __typename?: 'FieldError';
    field: Scalars['String']['output'];
    message: Scalars['String']['output'];
};
export type IGeoLocation = {
    __typename?: 'GeoLocation';
    coordinates?: Maybe<Array<Maybe<Scalars['Float']['output']>>>;
    type?: Maybe<Scalars['String']['output']>;
};
/**
 * Input geometry of the location.
 * List the `longitude` first and then `latitude`
 *  - Validate longitude values are between `-180` and `180`
 *  - Validate latitude values are between `-90` and `90`
 */
export type IGeoLocationInput = {
    coordinates?: InputMaybe<Array<InputMaybe<Scalars['Float']['input']>>>;
    type?: InputMaybe<Scalars['String']['input']>;
};
export type IIResourceUtilizationSettings = {
    adminApiNamespace?: Maybe<Scalars['String']['output']>;
    subTopic?: Maybe<Scalars['String']['output']>;
};
export declare enum IMailTemplateId {
    Dummy = "dummy"
}
export declare enum IMoleculerCronServiceName {
    Dummy = "dummy"
}
/**  All Moleculer Topic names are extended from this. */
export declare enum IMoleculerServiceName {
    SmsService = "SmsService",
    Dummy = "dummy"
}
export type IMutation = {
    __typename?: 'Mutation';
    dummy?: Maybe<Scalars['Int']['output']>;
    sendSms: Scalars['Boolean']['output'];
};
export type IMutationSendSmsArgs = {
    sms?: InputMaybe<ISendSmsInput>;
};
/** An object with an ID. */
export type INode = {
    /** The ID of the node. */
    id: Scalars['ID']['output'];
};
export type IPageInfo = {
    __typename?: 'PageInfo';
    hasNextPage: Scalars['Boolean']['output'];
};
export type IQuery = {
    __typename?: 'Query';
    /** Looks up a node by ID. */
    node?: Maybe<INode>;
};
export type IQueryNodeArgs = {
    id: Scalars['ID']['input'];
};
export type ISendSmsInput = {
    body: Scalars['String']['input'];
    to: Scalars['String']['input'];
};
export declare enum ISmsServiceActions {
    Send = "send"
}
export type ISort = {
    key: Scalars['String']['input'];
    value: ISortEnum;
};
export declare enum ISortEnum {
    Asc = "ASC",
    Desc = "DESC"
}
export type ISubscription = {
    __typename?: 'Subscription';
    dummy?: Maybe<Scalars['Int']['output']>;
};
export type ResolverTypeWrapper<T> = Promise<T> | T;
export type ResolverWithResolve<TResult, TParent, TContext, TArgs> = {
    resolve: ResolverFn<TResult, TParent, TContext, TArgs>;
};
export type Resolver<TResult, TParent = {}, TContext = {}, TArgs = {}> = ResolverFn<TResult, TParent, TContext, TArgs> | ResolverWithResolve<TResult, TParent, TContext, TArgs>;
export type ResolverFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => Promise<TResult> | TResult;
export type SubscriptionSubscribeFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => AsyncIterable<TResult> | Promise<AsyncIterable<TResult>>;
export type SubscriptionResolveFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
export interface SubscriptionSubscriberObject<TResult, TKey extends string, TParent, TContext, TArgs> {
    subscribe: SubscriptionSubscribeFn<{
        [key in TKey]: TResult;
    }, TParent, TContext, TArgs>;
    resolve?: SubscriptionResolveFn<TResult, {
        [key in TKey]: TResult;
    }, TContext, TArgs>;
}
export interface SubscriptionResolverObject<TResult, TParent, TContext, TArgs> {
    subscribe: SubscriptionSubscribeFn<any, TParent, TContext, TArgs>;
    resolve: SubscriptionResolveFn<TResult, any, TContext, TArgs>;
}
export type SubscriptionObject<TResult, TKey extends string, TParent, TContext, TArgs> = SubscriptionSubscriberObject<TResult, TKey, TParent, TContext, TArgs> | SubscriptionResolverObject<TResult, TParent, TContext, TArgs>;
export type SubscriptionResolver<TResult, TKey extends string, TParent = {}, TContext = {}, TArgs = {}> = ((...args: any[]) => SubscriptionObject<TResult, TKey, TParent, TContext, TArgs>) | SubscriptionObject<TResult, TKey, TParent, TContext, TArgs>;
export type TypeResolveFn<TTypes, TParent = {}, TContext = {}> = (parent: TParent, context: TContext, info: GraphQLResolveInfo) => Maybe<TTypes> | Promise<Maybe<TTypes>>;
export type IsTypeOfResolverFn<T = {}, TContext = {}> = (obj: T, context: TContext, info: GraphQLResolveInfo) => boolean | Promise<boolean>;
export type NextResolverFn<T> = () => Promise<T>;
export type DirectiveResolverFn<TResult = {}, TParent = {}, TContext = {}, TArgs = {}> = (next: NextResolverFn<TResult>, parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
/** Mapping of interface types */
export type IResolversInterfaceTypes<RefType extends Record<string, unknown>> = {
    IResourceUtilizationSettings: never;
    Node: never;
};
/** Mapping between all available schema types and the resolvers types */
export type IResolversTypes = {
    AdminIdeSettings: ResolverTypeWrapper<IAdminIdeSettings>;
    AnyObject: ResolverTypeWrapper<Scalars['AnyObject']['output']>;
    Boolean: ResolverTypeWrapper<Scalars['Boolean']['output']>;
    CacheControlScope: ICacheControlScope;
    Date: ResolverTypeWrapper<Scalars['Date']['output']>;
    DateTime: ResolverTypeWrapper<Scalars['DateTime']['output']>;
    EmptyResponse: ResolverTypeWrapper<IEmptyResponse>;
    FieldError: ResolverTypeWrapper<IFieldError>;
    Float: ResolverTypeWrapper<Scalars['Float']['output']>;
    GeoLocation: ResolverTypeWrapper<IGeoLocation>;
    GeoLocationInput: IGeoLocationInput;
    ID: ResolverTypeWrapper<Scalars['ID']['output']>;
    IResourceUtilizationSettings: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['IResourceUtilizationSettings']>;
    Int: ResolverTypeWrapper<Scalars['Int']['output']>;
    JSON: ResolverTypeWrapper<Scalars['JSON']['output']>;
    JSONObject: ResolverTypeWrapper<Scalars['JSONObject']['output']>;
    MailTemplateId: IMailTemplateId;
    MoleculerCronServiceName: IMoleculerCronServiceName;
    MoleculerServiceName: IMoleculerServiceName;
    Mutation: ResolverTypeWrapper<{}>;
    Node: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['Node']>;
    Observable: ResolverTypeWrapper<Scalars['Observable']['output']>;
    PageInfo: ResolverTypeWrapper<IPageInfo>;
    Query: ResolverTypeWrapper<{}>;
    SendSmsInput: ISendSmsInput;
    SmsServiceActions: ISmsServiceActions;
    Sort: ISort;
    SortEnum: ISortEnum;
    String: ResolverTypeWrapper<Scalars['String']['output']>;
    Subscription: ResolverTypeWrapper<{}>;
    Time: ResolverTypeWrapper<Scalars['Time']['output']>;
    URI: ResolverTypeWrapper<Scalars['URI']['output']>;
    URIInput: ResolverTypeWrapper<Scalars['URIInput']['output']>;
};
/** Mapping between all available schema types and the resolvers parents */
export type IResolversParentTypes = {
    AdminIdeSettings: IAdminIdeSettings;
    AnyObject: Scalars['AnyObject']['output'];
    Boolean: Scalars['Boolean']['output'];
    Date: Scalars['Date']['output'];
    DateTime: Scalars['DateTime']['output'];
    EmptyResponse: IEmptyResponse;
    FieldError: IFieldError;
    Float: Scalars['Float']['output'];
    GeoLocation: IGeoLocation;
    GeoLocationInput: IGeoLocationInput;
    ID: Scalars['ID']['output'];
    IResourceUtilizationSettings: IResolversInterfaceTypes<IResolversParentTypes>['IResourceUtilizationSettings'];
    Int: Scalars['Int']['output'];
    JSON: Scalars['JSON']['output'];
    JSONObject: Scalars['JSONObject']['output'];
    Mutation: {};
    Node: IResolversInterfaceTypes<IResolversParentTypes>['Node'];
    Observable: Scalars['Observable']['output'];
    PageInfo: IPageInfo;
    Query: {};
    SendSmsInput: ISendSmsInput;
    Sort: ISort;
    String: Scalars['String']['output'];
    Subscription: {};
    Time: Scalars['Time']['output'];
    URI: Scalars['URI']['output'];
    URIInput: Scalars['URIInput']['output'];
};
export type ICacheControlDirectiveArgs = {
    maxAge?: Maybe<Scalars['Int']['input']>;
    scope?: Maybe<ICacheControlScope>;
};
export type ICacheControlDirectiveResolver<Result, Parent, ContextType = any, Args = ICacheControlDirectiveArgs> = DirectiveResolverFn<Result, Parent, ContextType, Args>;
export type IAdminIdeSettingsResolvers<ContextType = any, ParentType extends IResolversParentTypes['AdminIdeSettings'] = IResolversParentTypes['AdminIdeSettings']> = {
    dummy?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export interface IAnyObjectScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['AnyObject'], any> {
    name: 'AnyObject';
}
export interface IDateScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Date'], any> {
    name: 'Date';
}
export interface IDateTimeScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['DateTime'], any> {
    name: 'DateTime';
}
export type IEmptyResponseResolvers<ContextType = any, ParentType extends IResolversParentTypes['EmptyResponse'] = IResolversParentTypes['EmptyResponse']> = {
    alwaysNil?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IFieldErrorResolvers<ContextType = any, ParentType extends IResolversParentTypes['FieldError'] = IResolversParentTypes['FieldError']> = {
    field?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    message?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGeoLocationResolvers<ContextType = any, ParentType extends IResolversParentTypes['GeoLocation'] = IResolversParentTypes['GeoLocation']> = {
    coordinates?: Resolver<Maybe<Array<Maybe<IResolversTypes['Float']>>>, ParentType, ContextType>;
    type?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIResourceUtilizationSettingsResolvers<ContextType = any, ParentType extends IResolversParentTypes['IResourceUtilizationSettings'] = IResolversParentTypes['IResourceUtilizationSettings']> = {
    __resolveType: TypeResolveFn<null, ParentType, ContextType>;
    adminApiNamespace?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    subTopic?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
};
export interface IJsonScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['JSON'], any> {
    name: 'JSON';
}
export interface IJsonObjectScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['JSONObject'], any> {
    name: 'JSONObject';
}
export type IMutationResolvers<ContextType = any, ParentType extends IResolversParentTypes['Mutation'] = IResolversParentTypes['Mutation']> = {
    dummy?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    sendSms?: Resolver<IResolversTypes['Boolean'], ParentType, ContextType, Partial<IMutationSendSmsArgs>>;
};
export type INodeResolvers<ContextType = any, ParentType extends IResolversParentTypes['Node'] = IResolversParentTypes['Node']> = {
    __resolveType: TypeResolveFn<null, ParentType, ContextType>;
    id?: Resolver<IResolversTypes['ID'], ParentType, ContextType>;
};
export interface IObservableScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Observable'], any> {
    name: 'Observable';
}
export type IPageInfoResolvers<ContextType = any, ParentType extends IResolversParentTypes['PageInfo'] = IResolversParentTypes['PageInfo']> = {
    hasNextPage?: Resolver<IResolversTypes['Boolean'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IQueryResolvers<ContextType = any, ParentType extends IResolversParentTypes['Query'] = IResolversParentTypes['Query']> = {
    node?: Resolver<Maybe<IResolversTypes['Node']>, ParentType, ContextType, RequireFields<IQueryNodeArgs, 'id'>>;
};
export type ISubscriptionResolvers<ContextType = any, ParentType extends IResolversParentTypes['Subscription'] = IResolversParentTypes['Subscription']> = {
    dummy?: SubscriptionResolver<Maybe<IResolversTypes['Int']>, "dummy", ParentType, ContextType>;
};
export interface ITimeScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Time'], any> {
    name: 'Time';
}
export interface IUriScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['URI'], any> {
    name: 'URI';
}
export interface IUriInputScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['URIInput'], any> {
    name: 'URIInput';
}
export type IResolvers<ContextType = any> = {
    AdminIdeSettings?: IAdminIdeSettingsResolvers<ContextType>;
    AnyObject?: GraphQLScalarType;
    Date?: GraphQLScalarType;
    DateTime?: GraphQLScalarType;
    EmptyResponse?: IEmptyResponseResolvers<ContextType>;
    FieldError?: IFieldErrorResolvers<ContextType>;
    GeoLocation?: IGeoLocationResolvers<ContextType>;
    IResourceUtilizationSettings?: IIResourceUtilizationSettingsResolvers<ContextType>;
    JSON?: GraphQLScalarType;
    JSONObject?: GraphQLScalarType;
    Mutation?: IMutationResolvers<ContextType>;
    Node?: INodeResolvers<ContextType>;
    Observable?: GraphQLScalarType;
    PageInfo?: IPageInfoResolvers<ContextType>;
    Query?: IQueryResolvers<ContextType>;
    Subscription?: ISubscriptionResolvers<ContextType>;
    Time?: GraphQLScalarType;
    URI?: GraphQLScalarType;
    URIInput?: GraphQLScalarType;
};
export type IDirectiveResolvers<ContextType = any> = {
    cacheControl?: ICacheControlDirectiveResolver<any, any, ContextType>;
};
